#include <string.h>
#include <things.h>
#include <qdos.h>
#include <csrvthg.h>

/*
 * Here's an unsupported way to use the undocumented CSM Usage list
 * structure to make see if the server exists.
 *
 */

typedef struct __csm_use
{
    struct  __csm_use *next;
    long    OSprivate[3];
    long    flag;
    long    jobid;
    long    chi;
    long    cho;
    short   namlen;
    char    nam[1];
} CSM_USAGE;

void qfaxcsm(char *cmd)
{
    int n;
    if(UseSrvThg(CLNT, "QFAX") >= 0)
    {
        Request("QFAX", cmd, -1, NULL);
	FreeSrvThg (CLNT, "QFAX");
    }
}


short served(char *srv)
{
    static const char csm[] = "Client Server";
    short amserved = 0;
    THING_LINKAGE *p;
    size_t nlen = strlen(srv);

    for( p = *((THING_LINKAGE **)(_sys_var + 0xb8)); 
	 p && !amserved; p = p->th_nxtth)
    {
        if(p->th_name == (sizeof(csm)-1))
        {
            if(strnicmp(csm, p->th_name_text, (sizeof(csm)-1)) == 0)
            {
                CSM_USAGE *c, *k;
                for( c = (CSM_USAGE *)p->th_usage; c; c = k)
                {
                    k = c->next;
                    if(c->flag == SRVR && 
		       c->namlen == nlen && strncmp(c->nam, srv, nlen) == 0)
                    {
			    amserved = 1;
			    break;
                    }
                }
            }
        }
    }
    return amserved;
}

#ifdef TEST
#include <stdio.h>
int main(int ac, char **av)
{
    printf("served for %s, %d\n", *(av+1), served(*(av+1)));
    return 0;
}
#endif
